#ifndef _BUFFER_H_
#define _BUFFER_H_

typedef struct {
  unsigned char *data;
  int play_next; /* next buffer to play, buffer unit */
  int putpos;    /* next pos to put data, byte unit */
  int len;       /* number of buffers */
  int size;      /* number of bytes */
  int count;     /* number of occupied buffers */
  int partial;   /* number of bytes in next buffer already put */
  unsigned long store_count;   /* total number of bytes passed in buffer */
  unsigned long buffer_size;   /* size of a buffer, byte unit */
} obuf;

void obuf_init(obuf *, unsigned long, unsigned long);
int obuf_hasroom(obuf *);
int obuf_isempty(obuf *);
void obuf_put(obuf *, unsigned char *, int);
unsigned char *obuf_play(obuf *);
void obuf_fill(obuf *);

#endif /* _BUFFER_H_ */
