#include "data.h"
#include "oss.h"
#include "alsa.h"

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <math.h>

int pid;

playlist list;

volatile int skip_silence;

#define NB_BUFFERS 10

void usr2(int x)
{
  skip_silence = 1;
}

void vol_up(int x)
{
  extern volatile int vol;
  extern volatile float volr;
  vol++;
  volr = pow(10, vol / 20.);
  printf("\nvolume %d (%g)\n", vol, volr);
}

void vol_down(int x)
{
  extern volatile int vol;
  extern volatile float volr;
  vol--;
  volr = pow(10, vol / 20.);
  printf("\nvolume %d (%g)\n", vol, volr);
}

int main(int n, char **v)
{
  if (n != 2) { fprintf(stderr, "play <playlist> (- for input)\n"); return 1; }

  signal(SIGUSR2, usr2);
  signal(40, vol_up);
  signal(41, vol_down);

  init_filter();

#ifndef ALSA
  if (!init_oss("/dev/dsp", 44100, 16, 1, NB_BUFFERS-1, 12, PLAY_SOUND))
    exit(0);
#else
  init_alsa();
#endif

  pid = getpid();
  printf("volume up: kill -40 %d\n", pid);
  printf("volume down: kill -41 %d\n", pid);

  load_list(&list, v[1]);
  play(&list);

#ifdef ALSA
  end_alsa();
#endif

  printf("\ndone\n");

  return 0;
}
